-- VS PLAYER PORTRAIT
function GoH_VS_Player_Portrait_Update()

	local GoH_ispvp = UnitIsPVP("player");

	SetPortraitTexture(GoH4_PlayerTexture,"player");
	SetPortraitTexture(GoH4_PlayerTexture2,"player");

	if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
		-- WELL YOU'RE IN COMBAT, YIPPY
		if GoH_ispvp == 1 then
			-- FLAGGED FOR PVP
			GoH4_MK_PlayerOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_FLAGGED_COMBAT.tga");
			GoH4_MK_Player_FLAGGED_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_YOU_PVP.tga");
		else
			GoH4_MK_PlayerOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_COMBAT.tga");
			GoH4_MK_Player_FLAGGED_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
			-- NOT FLAGGED FOR PVP
		end
	else
		-- NOT IN COMBAT
		if GoH_ispvp == 1 then
			-- FLAGGED FOR PVP
			GoH4_MK_PlayerOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_FLAGGED.tga");
			GoH4_MK_Player_FLAGGED_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_YOU_PVP.tga");
		else
			GoH4_MK_PlayerOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE.tga");
			GoH4_MK_Player_FLAGGED_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
			-- NOT FLAGGED FOR PVP
		end
	end
	GoH4_Player_Level_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_LEVEL_"..GoH_DeathKnight.CharLevel..".tga");

	local GoH_factionGroup = UnitFactionGroup("player");

	    if ( GoH_factionGroup ) then
        	if ( GoH_factionGroup == "Alliance" ) then
        		-- ALLIANCE
        		GoH4_Player_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_FACTION_ALLIANCE.tga");
        	elseif ( GoH_factionGroup == "Horde" ) then
        		-- HORDE
        		GoH4_Player_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_FACTION_HORDE.tga");
        	else
        		-- NEUTRAL
        		GoH4_Player_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
        	end
		else
			-- NEUTRAL
			GoH4_Player_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
        end

		if UnitIsDND("player") then
			-- DND MODE
			GoH4_Player_BUSY_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_DND.tga");
		end
		if UnitIsAFK("player") then
			-- AFK MODE
			GoH4_Player_BUSY_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_AFK.tga");
		end
		if ((not UnitIsDND("player")) and (not UnitIsAFK("player"))) then
			-- NOT IN DND OR AFK
			GoH4_Player_BUSY_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
		end

end

function GoH_VS_Target_Portrait_Update()
-- VS TARGET PORTRAIT

	-- "Humanoid"
	-- "Critter"
	-- "Beast"
	-- "Dragonkin"
	-- "Demon"
	-- "Elemental"
	-- "Giant"
	-- "Undead"
	-- "Mechanical"
	-- "Gas Cloud"
	-- "Totem"
	-- "Non-combat Pet"
	-- "Wild Pet"
	-- "Not specified"
	-- "Player"

	local GoH_ispvp_Target = UnitIsPVP("target");

		if (UnitExists("target")) then

			if GoHv5_DeathKnight_Data.config.Use_VS_HUD_TARGET_ONLY == "YES" then
				GoH4_Target:Show();
				GoH4_VS:Show();
			end

			local Check_Unit_Type_GOH = UnitCreatureType("target");
			local Check_Known_Type_GoH = " unknown entity!";

			local guid = UnitGUID("target");
			if guid ~= nil then
				local B = tonumber(guid:sub(5,5), 16);
				local maskedB = B % 8; -- x % 8 has the same effect as x & 0x7 on numbers <= 0xf
				local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
				Check_Known_Type_GoH = (knownTypes[maskedB] or " unknown entity!");
			end
			-- print(Check_Known_Type_GoH);


			if Check_Known_Type_GoH == "player" then

				if GoH_ispvp_Target == 1 then
					-- FLAGGED FOR PVP
					GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_PLAYER_PVP.tga");
				else
					-- NOT FLAGGED FOR PVP
					GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_PLAYER.tga");
				end

			else

				if (Check_Unit_Type_GOH == "Humanoid") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_HUMANOID_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_HUMANOID.tga");
					end

				elseif (Check_Unit_Type_GOH == "Critter") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_CRITTER_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_CRITTER.tga");
					end

				elseif (Check_Unit_Type_GOH == "Beast") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BEAST_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BEAST.tga");
					end

				elseif (Check_Unit_Type_GOH == "Dragonkin") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_DRAGONKIN_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_DRAGONKIN.tga");
					end

				elseif (Check_Unit_Type_GOH == "Demon") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_DEMON_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_DEMON.tga");
					end

				elseif (Check_Unit_Type_GOH == "Elemental") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_ELEMENTAL_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_ELEMENTAL.tga");
					end

				elseif (Check_Unit_Type_GOH == "Giant") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_GIANT_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_GIANT.tga");
					end

				elseif (Check_Unit_Type_GOH == "Undead") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_UNDEAD_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_UNDEAD.tga");
					end

				elseif (Check_Unit_Type_GOH == "Mechanical") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_MECHANICAL_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_MECHANICAL.tga");
					end

				elseif (Check_Unit_Type_GOH == "Gas Cloud") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_GASCLOUD_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_GASCLOUD.tga");
					end

				elseif (Check_Unit_Type_GOH == "Non-combat Pet") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_NONCOMBATPET_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_NONCOMBATPET.tga");
					end

				elseif (Check_Unit_Type_GOH == "Wild Pet") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_WILDPET_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_WILDPET.tga");
					end

				elseif (Check_Unit_Type_GOH == "Not specified") then

					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_NOTSPECIFIED_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_NOTSPECIFIED.tga");
					end

				else

					GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");

				end

			end

		else

			if GoHv5_DeathKnight_Data.config.Use_VS_HUD_TARGET_ONLY == "YES" then
				if GoH_Frame_Page2:IsVisible() then
					GoH4_Target:Show();
					GoH4_VS:Show();
				else
					GoH4_Target:Hide();
					GoH4_VS:Hide();
				end
			elseif GoHv5_DeathKnight_Data.config.Use_VS_HUD_TARGET_ONLY == "NO" then
				GoH4_Target:Show();
				GoH4_VS:Show();
				GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
			end
		end

	local GoH_Classification = UnitClassification("target");
	-- print(GoH_Classification);
	-- "worldboss", "rareelite", "elite", "rare", "normal", "trivial" or "minus"

	SetPortraitTexture(GoH4_TargetTexture,"target");
	SetPortraitTexture(GoH4_TargetTexture2,"target");

	if GoH_Classification == "rare" then
			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RARE_COMBAT_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RARE_COMBAT.tga");
					end
			else
				-- NOT IN COMBAT
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RARE_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RARE.tga");
					end
			end

	elseif GoH_Classification == "rareelite" then
			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RARE_COMBAT_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RAREELITE_COMBAT.tga");
					end
			else
				-- NOT IN COMBAT
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RAREELITE_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_RAREELITE.tga");
					end
			end

	elseif GoH_Classification == "elite" then
			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_ELITE_COMBAT_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_ELITE_COMBAT.tga");
					end
			else
				-- NOT IN COMBAT
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_ELITE_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_ELITE.tga");
					end
			end


	elseif GoH_Classification == "worldboss" then
			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_WORLDBOSS_COMBAT_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_WORLDBOSS_COMBAT.tga");
					end
			else
				-- NOT IN COMBAT
					if GoH_ispvp_Target == 1 then
						-- FLAGGED FOR PVP
						GoH4_MK_Target_TYPE_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_WORLDBOSS_FLAGGED.tga");
					else
						-- NOT FLAGGED FOR PVP
						GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_WORLDBOSS.tga");
					end
			end

	else
			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY
				if GoH_ispvp_Target == 1 then
					-- FLAGGED FOR PVP
					GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_FLAGGED_COMBAT.tga");
				else
					GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_COMBAT.tga");
					-- NOT FLAGGED FOR PVP
				end
			else
				-- NOT IN COMBAT
				if GoH_ispvp_Target == 1 then
					-- FLAGGED FOR PVP
					GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE_FLAGGED.tga");
				else
					GoH4_MK_TargetOVERLAYTexture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_OUTLINE.tga");
					-- NOT FLAGGED FOR PVP
				end
			end

	end
	local GoH_TargetLevel_Temp = UnitLevel("target");
	if ((GoH_TargetLevel_Temp ~= nil) and (GoH_TargetLevel_Temp ~= 0) and (GoH_TargetLevel_Temp ~= -1)) then
		GoH4_Target_Level_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_LEVEL_"..GoH_TargetLevel_Temp..".tga");
	elseif (GoH_TargetLevel_Temp == -1) then
		GoH4_Target_Level_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_LEVEL_QUESTION_MARKS.tga");
	else
		GoH4_Target_Level_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
	end

	local GoH_factionGroup = UnitFactionGroup("target");

	    if ( GoH_factionGroup ) then
        	if ( GoH_factionGroup == "Alliance" ) then
        		-- ALLIANCE
        		GoH4_Target_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_FACTION_ALLIANCE.tga");
        	elseif ( GoH_factionGroup == "Horde" ) then
        		-- HORDE
        		GoH4_Target_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_FACTION_HORDE.tga");
        	else
        		-- NEUTRAL
        		GoH4_Target_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
        	end
		else
			-- NEUTRAL
			GoH4_Target_Faction_Texture:SetTexture("Interface\\AddOns\\GoH\\Images\\GoH_VERSUS_TYPE_BLANK.tga");
        end

end

